/*
ccash.cpp - an incomplete currency library.
Copyright (C) 2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 

*/
#include <cstring>
#include <cmath>
#include <cstdio>

#include "cash.h"

namespace bhpos{

////////////////////////////////////////////////////////

CMoney::CMoney() 
{ 
	unit=0;
	value=1.0;
	amount=0; 
}

CMoney::CMoney(const CMoney& m) 
{
	unit=m.unit;
	value=m.value;
	amount=m.amount;
}

CMoney::~CMoney() 
{
}

CMoney::CMoney(int u, double v, double a) 
{ 
	unit=u;
	value=v;
	amount=(int) ((double) a/v); 
}
CMoney::CMoney(int u, double v, int a) 
{ 
	unit=u;
	value=v;
	amount=a; 
}

CMoney &CMoney::operator=(const CMoney& m)
{
	this->unit=m.unit;
	this->value=m.value;
	this->amount=m.amount;
	
	return *this;
}

bool CMoney::operator==(const CMoney& m)
{
	if(m.unit==unit && m.value==value) return true;
	return false;
}

bool CMoney::operator!=(const CMoney& m)
{
	if(m.unit!=unit && m.value!=value) return true;
	return false;
}
bool CMoney::operator==(const double& d)
{
	if(d==value) return true;
	return false;
}

bool CMoney::operator!=(const double& d)
{
	if(d!=value) return true;
	return false;
}
	
bool CMoney::operator<(const CMoney& m)
{
	if(unit==m.unit && value < m.value) return true;
	return false;
}

bool CMoney::operator<(const double& m)
{
	if(GetAmount() < m) return true;
	return false;
}
bool CMoney::operator>(const CMoney& m)
{
	if(unit==m.unit && value > m.value) return true;
	return false;
}
bool CMoney::operator>(const double& m)
{
	if(GetAmount() > m) return true;
	return false;
}

void CMoney::Set(int u, double v, double a)
{
	unit=u;
	value=v;
	amount=(int) ceil(((double) a/v));
}
void CMoney::Set(int u, double v, int a)
{
	unit=u;
	value=v;
	amount=a;
}
/*!
   Set the amount using a real value 
*/
int CMoney::SetAmount(double a)
{
	amount=(int) ceil(((double) a / value));
	return 0;
}
/*!
   Set the amount using integer quantity 
*/
int CMoney::SetAmount(int a)
{
	amount=a;
	return 0;
}
/*!
   Get the real amount
*/
double CMoney::GetAmount()
{
	return ceil(amount * value);
}
double CMoney::GetValue()
{
	return value;
}
int CMoney::SetValue(double v)
{
	value=v;
	return 0;
}
int CMoney::GetNumber()
{
	return amount;
}
int CMoney::GetUnit()
{
	return unit;
}
int CMoney::GetQuantity(double s)
{
	return ((int)(value/s));
}
int CMoney::Add(double a)
{
	if((((int)(a*100))%((int)(value*100)))!=0) return 1;
	int n=(int) ceil(a/value);
	amount+=n;
	return 0;
}
int CMoney::Add(int a)
{
	amount+=a;
	return amount;
}
int CMoney::Subtract(double a)
{
	if((((int)(a*100))%((int)(value*100)))!=0) return 1;
	int n=(int) ceil(a/value);
	amount-=n;
	return 0;
}
int CMoney::Subtract(int a)
{
	amount-=a;
	return amount;
}


///////////////////////////////////////////////////////////////////


CCash::CCash()
{
   total_units=0;
	smallest_unit=0.0000001;
}

CCash::CCash(const CCash& c)
{
	current=c.current;
	total_units=c.total_units;
	smallest_unit=c.smallest_unit;
}

CCash::~CCash()
{
	current.clear();
}

CCash &CCash::operator=(const CCash& c)
{
	this->current=c.current;
	this->total_units=c.total_units;
	this->smallest_unit=c.smallest_unit;
	
	return *this;
}

bool CCash::operator==(CCash& c)
{
   CMoney m;
   int    i=0;
   std::list<CMoney>::iterator ci;
	
	for(ci=current.begin(); ci!=current.end(); ci++){
	   if(c.GetMoneyUnit(i, m)) return false;
		if(*ci!=m){
			return false;
		}
		i++;
	}
	
	return true;
}

bool CCash::operator!=(CCash& c)
{
   CMoney m;
   int    i=0;
   std::list<CMoney>::iterator ci;

	
	for(ci=current.begin(); ci!=current.end(); ci++){
	   if(c.GetMoneyUnit(i, m)) return false;
		if(*ci==m){
			return false;
		}
		i++;
	}
	return true;
}

bool CCash::operator<(CCash& c)
{
	return false;
	
	if(GetTotal() < c.GetTotal()) return true;
	return false;
}

void CCash::operator+=(CCash& c)
{
   CMoney m;
   int    i=0;
   std::list<CMoney>::iterator ci;
	
	for(ci=current.begin(); ci!=current.end(); ci++){
	   if(c.GetMoneyUnit(i, m)) return;
		ci->Add(m.GetAmount());
		i++;
	}
}

void CCash::operator-=(CCash& c)
{
   CMoney m;
   int    i=0;
   std::list<CMoney>::iterator ci;
	
	for(ci=current.begin(); ci!=current.end(); ci++){
	   if(c.GetMoneyUnit(i, m)) return;
		ci->Subtract(m.GetAmount());
		i++;
	}
}

int CCash::Clear()
{
	std::list<CMoney>::iterator i;

	for(i=current.begin(); i!=current.end(); i++){
		i->SetAmount(0);
	}
	total_units=0;
	smallest_unit=0.0000001;
	return 0;	
}

int CCash::Add(CMoney& m)
{
	current.push_back(m);
	total_units+=((int) (m.GetAmount()/m.GetValue()));
	if(m.GetValue() < smallest_unit) smallest_unit=m.GetValue();
	return 0;
}

int CCash::Add(int u, double v, int a)
{
	std::list<CMoney>::iterator i;
	CMoney m(u, v, a);

	for(i=current.begin(); i!=current.end(); i++){
		if(*i==m){
			return 1;
		}
	}
	if(i==current.end()){
		current.push_back(m);
	}
	else{
		return 1;
	}
	if(v < smallest_unit) smallest_unit=v;
   total_units+=u*a;
	return 0;
}

int CCash::Update(CMoney& m)
{
	std::list<CMoney>::iterator i=find(current.begin(), current.end(), m);
	if(i==current.end()) return 1;
	
	*i=m;
	return 0;
}
void CCash::Total()
{
	std::list<CMoney>::iterator i;
	total_units=0;
	for(i=current.begin(); i!=current.end(); i++){
		total_units+=i->GetQuantity(smallest_unit);
	}
}
/*
int CCash::NumUnits()
{
	return total_units;
}
*/
int CCash::NumMoneyUnits()
{
	return current.size();
}

int CCash::GetMoneyUnit(int num, CMoney& m)
{
	std::list<CMoney>::iterator i=current.begin();
	
	for(int x=0; x!=num; x++, i++);
	
	if(i==current.end()) return 1;
	
	m=*i;
	return 0;
}

int CCash::AdjustAmount(int u, double v, int a)
{
	std::list<CMoney>::iterator i;
	CMoney m(u, v, a);

	for(i=current.begin(); i!=current.end(); i++){
		if(*i==m){
			i->SetAmount(a);
			return 0;
		}
	}
	if(i==current.end()){
		return 1;
	}
	return 0;
}

double CCash::GetAmount(int u, double v)
{
	std::list<CMoney>::iterator i;
	CMoney m(u, v, 0.0f);

	for(i=current.begin(); i!=current.end(); i++){
		if(*i==m){
			return i->GetAmount();
		}
	}
	if(i==current.end()){
		return 0.0f;
	}
	return 0.0f;
}

int CCash::GetPhyscialNumber(int u, double v)
{
   std::list<CMoney>::iterator i;
	CMoney m(u, v, 0.0f);

	for(i=current.begin(); i!=current.end(); i++){
		if(*i==m){
			return i->GetNumber();
		}
	}
	return 0;
}

double CCash::GetTotal()
{
	std::list<CMoney>::iterator i;
	double f=0.0;

	for(i=current.begin(); i!=current.end(); i++){
		f+=i->GetAmount();
	}
	return f;
}

float CCash::AddTo(float amount)
{
   if(current.empty()) return 0.0;
      
   std::list<CMoney>::iterator i=current.end();
	float remainder=amount;
	float num=0.0;
	int	count=0;
   char  buff[32];
	
   i--;
   
	while(i!=current.begin() || remainder > 0.0){
      sprintf(buff, "%0.2f", remainder);
      remainder=strtof(buff, NULL);
      num=remainder/i->GetValue();
		if((num=remainder/i->GetValue()) >= 1.0){
			count=(int) num;
			i->Add(count);
			remainder-=(count * i->GetValue());
		}
		i--;
	}
	
	return GetTotal();
}

float CCash::Remove(float amount)
{
	std::list<CMoney>::iterator i=current.end();
	float remainder=amount;
	double num=0.0;
	int	count=0, c=1;
   char  buff[32];

   i--;
   
	while(i!=current.begin() && remainder > 0.0){
      sprintf(buff, "%0.2f", remainder);
      remainder=strtof(buff, NULL);
      num=remainder/i->GetValue();
      if(num >= 1.0){
			// actual physical amounts cannot be negative
			count=(int) num;
			if(i->GetNumber()==0){
				i--;
				continue;
			}
			while(count > i->GetNumber()){
				count--;
				if(count==0){
					i--;
					continue;
				}
			}
			i->Subtract(count);
			remainder-=(count * i->GetValue());
		}
		i--;
      c++;
      if(c > 15) return 0.0;
	}
	
	return GetTotal();
}

}
