/*
bhcfg.h
Copyright (C)2001  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _BH_CFG_
#define _BH_CFG_

#define RECSIZE 1024

#include <cstdio>

namespace BhPos{

/**
 * @defgroup bhcfg Configuration
 * @{
 *
 * \ingroup commlib
 * @{	
 */
/*! \brief A class to handle config files.*/
class CConfig
{
private:
	FILE	*hFile;
	bool	bVerboseMode;
	bool	bInDefault;
	bool	bInNode;

	char sRecName[64];
	char sKeyName[RECSIZE];
	char sDefaultValue[RECSIZE];
	char sSpecificValue[RECSIZE];
	
//	struct utsname unamebuf;
	
protected:
	char *GetNextRec();
	char *GetNextToRec(fpos_t *pos);
	bool  ParseLine(char *, char *);
	bool  ParseToLine(char *, fpos_t);
	void  Strim(char *);

public:
	CConfig();
	~CConfig();

	bool Load(char *fname);   // read only
	bool Open(char *fname);   // read/write
	bool ParseRecord(char *rec, char *name, char *value);
	bool ParseString(char *rec, char *name, char *string, char *);
	bool ParseInt(char *rec, char *name, int *value, int);
	bool ParseDouble(char *rec, char *name, double *value, double);
	bool ParseBool(char *rec, char *name, bool *value, bool);
	bool ParseString(char *rec, char *name, char *string);
	bool ParseInt(char *rec, char *name, int *value);
	bool ParseDouble(char *rec, char *name, double *value);
	bool ParseBool(char *rec, char *name, bool *value);
	
	bool WriteRecord(char *rec, char *name, char *value);
};

/* @} 
	@} */

}

#endif	//	_BH_CFG_
