/*
csaleitem.cpp - a sale item shared library.

Copyright (C) 2001 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "ctransitems.h"

namespace bhpos{

CSaleItem::CSaleItem()
{
	plutype=BHSI_PLUTYPE_UNKNOWN;
   discount_type=BHSI_DISCOUNT_NONE;
   deposit_type=BHSI_DEPOSIT_NONE;
	type=BHSI_SITYPE_PLU;
   PLU="";
	displayText="";
	recuText="";
	quantity=1;
	tax=0.0f;
	discount=0.0f;
	unitPrice=0.0f;
	deposit=0.0f;
	flags=0;
   reason=0;
	site=0;
   dept=0;
   group=0;
   station=0;
   user=0;
	flag_msg="";
   deposit_name="";
}

CSaleItem::CSaleItem(std::string& p)
{
   PLU=p;
   
   plutype=BHSI_PLUTYPE_UNKNOWN;
   discount_type=BHSI_DISCOUNT_NONE;
   deposit_type=BHSI_DEPOSIT_NONE;
	type=BHSI_SITYPE_PLU;
	displayText="";
	recuText="";
	quantity=1;
	tax=0.0f;
	discount=0.0f;
	unitPrice=0.0f;
	deposit=0.0f;
	flags=0;
   reason=0;
	site=0;
   dept=0;
   group=0;
   station=0;
   user=0;
	flag_msg="";
   deposit_name="";
}

CSaleItem::CSaleItem(Glib::ustring& p)
{
   PLU=p;
   
   plutype=BHSI_PLUTYPE_UNKNOWN;
   discount_type=BHSI_DISCOUNT_NONE;
   deposit_type=BHSI_DEPOSIT_NONE;
	type=BHSI_SITYPE_PLU;
	displayText="";
	recuText="";
	quantity=1;
	tax=0.0f;
	discount=0.0f;
	unitPrice=0.0f;
	deposit=0.0f;
	flags=0;
   reason=0;
	site=0;
   dept=0;
   group=0;
   station=0;
   user=0;
	flag_msg="";
   deposit_name="";
}

CSaleItem::CSaleItem(const CSaleItem& si)
{
	plutype=si.plutype;
   discount_type=si.discount_type;
   deposit_type=si.deposit_type;
	type=si.type;
   //if(si.PLU!=NULL) SetPLU(si.PLU);
   PLU=si.PLU;
	displayText=si.displayText;
	recuText=si.recuText;
	quantity=si.quantity;
	tax=si.tax;
	discount=si.discount;
	unitPrice=si.unitPrice;
	deposit=si.deposit;
   reason=si.reason;
	flags=si.flags;
	site=si.site;
   dept=si.dept;
   group=si.group;
   station=si.station;
   user=si.user;
   flag_msg=si.flag_msg;
   deposit_name=si.deposit_name;
	timestamp=si.timestamp;
}

CSaleItem::~CSaleItem()
{
}

CSaleItem &CSaleItem::operator=(const CSaleItem& si)
{
	this->plutype=si.plutype;
   this->discount_type=si.discount_type;
   this->deposit_type=si.deposit_type;
	this->type=si.type;
   this->PLU=si.PLU;
	this->displayText=si.displayText;
	this->recuText=si.recuText;
	this->quantity=si.quantity;
	this->tax=si.tax;
	this->discount=si.discount;
	this->unitPrice=si.unitPrice;
	this->deposit=si.deposit;
   this->reason=si.reason;
	this->flags=si.flags;
	this->site=si.site;
   this->dept=si.dept;
   this->group=si.group;
   this->station=si.station;
   this->user=si.user;
   this->flag_msg=si.flag_msg;
   this->deposit_name=si.deposit_name;
	timestamp=si.timestamp;
	
	return *this;
}
/*
CSaleItem* CSaleItem::operator&()
{
   return this;
}
*/
bool CSaleItem::operator==(const CSaleItem& s)
{
   if(PLU==s.PLU  && type==s.type){
	//if(PLU==NULL || s.PLU==NULL) return false;
	//if((strcmp(PLU, s.PLU)==0) && type==s.type){
      if(type==BHSI_SITYPE_RETURN){
         if(flags==s.flags) return true;
            else return false;
      }
      else return true;
   }
	return false;
}
bool CSaleItem::operator!=(const CSaleItem& s)
{
   if(PLU==s.PLU  && type==s.type) return false;
	//if(PLU==NULL || s.PLU==NULL) return false;
	//if((strcmp(PLU, s.PLU)!=0) && type!=s.type){
//      if(type==BHSI_SITYPE_RETURN){
  //       if(flags!=s.flags) return true;
    //     else return false;
      //}
//      else return false;
  // }
	return true;
}
bool CSaleItem::operator<(const CSaleItem& s)
{
	//if(PLU==NULL || s.PLU==NULL) return false;
	//if(strcmp(PLU, s.PLU) < 0) return true;
	return false;
}

void CSaleItem::Clear()
{
	plutype=BHSI_PLUTYPE_UNKNOWN;
   discount_type=BHSI_DISCOUNT_NONE;
   deposit_type=BHSI_DEPOSIT_NONE;
	type=BHSI_SITYPE_PLU;
   PLU="";
   displayText="";
   recuText="";
   quantity=1;
	tax=0.0f;
	discount=0.0f;
	unitPrice=0.0f;
	deposit=0.0f;
   reason=0;
	flags=0;
	site=0;
   dept=0;
   group=0;
   station=0;
   user=0;
   // clear the dt
	flag_msg="";
   deposit_name="";
}

const int CSaleItem::PluSize()
{
   return PLU.size();
	//if(PLU) return PLU.size;
   //else return 0;
}
const unsigned char CSaleItem::GetPluType()
{
	return plutype;
}
void CSaleItem::SetPluType(unsigned char t)
{
	plutype=t;
}

const Glib::ustring CSaleItem::GetPLU()
{
   return PLU;
}

bool CSaleItem::SetPLU(const char *p)
{
   PLU=p;
	return true;
}
bool CSaleItem::SetPLU(Glib::ustring p)
{
   PLU=p;
   return true;
}

const Glib::ustring CSaleItem::GetDispText()
{
	return displayText;
}

bool CSaleItem::SetDispText(char *d)
{
	displayText=d;
	return true;
}

bool CSaleItem::SetDispText(Glib::ustring d)
{
	displayText=d;
	return true;
}

const Glib::ustring CSaleItem::GetRecText()
{
	return recuText.c_str();
}

bool CSaleItem::SetRecText(char *r)
{
	recuText=r;
	return true;
}

bool CSaleItem::SetRecText(Glib::ustring r)
{
	recuText=r;
	return true;
}

const int CSaleItem::GetQuantity()
{
	return quantity;
}

bool CSaleItem::SetQuantity(int q)
{
	quantity=q;
	return false;
}

const float CSaleItem::GetTax()
{
	return tax;
}

bool CSaleItem::SetTax(float t)
{
	tax=t;
	return false;
}

const float CSaleItem::GetDiscount()
{
	return discount;
}

bool CSaleItem::SetDiscount(float d)
{
	discount=d;
	return false;
}

void CSaleItem::SetDeposit(float d)
{
	deposit=d;
}

const float CSaleItem::GetDeposit()
{
	return deposit;
}

void CSaleItem::SetDepositName(char *n)
{
   deposit_name=n;
}

const Glib::ustring CSaleItem::GetDepositName()
{
   return deposit_name;
}

const float CSaleItem::GetPrice()
{
	return unitPrice;
}

bool CSaleItem::SetPrice(float p)
{
	unitPrice=p;
	return false;
}

const float CSaleItem::GetTotalDiscount()
{
   return ((float) (unitPrice * discount) * quantity);
}

const float CSaleItem::GetSubTotal()
{
	return ((float) (unitPrice * quantity));
}

const float CSaleItem::GetTotal()
{
	return ((float) (unitPrice - (unitPrice * discount)) * quantity);
}

const float CSaleItem::GetTotal(bool bTaxInclusive)
{
   float p=(unitPrice * quantity)-(unitPrice * discount);
	if(bTaxInclusive){
      //printf("pinc:%0.2f - tax:%0.2f\n",(p + (p * tax)), tax);
      return (p + (p * tax));
   }
   else{
      return p;
   }
}

void CSaleItem::SetMsg(char *m)
{
	flag_msg=m;
}

void CSaleItem::SetMsg(Glib::ustring m)
{
	flag_msg=m;
}

const Glib::ustring CSaleItem::GetMsg()
{
	return flag_msg;
}

void CSaleItem::SetType(int t)
{
	type=t;
}

const int CSaleItem::GetType()
{
	return type;
}

void CSaleItem::SetWhere(char *w)
{
   if(w==NULL) return;
   
   char temp[6];
   
   memcpy(temp, w, 5);
   temp[6]=0;
   site=atoi(temp);
   memcpy(temp, &w[5], 5);
   temp[6]=0;
   dept=atoi(temp);
   memcpy(temp, &w[10], 5);
   temp[6]=0;
   group=atoi(temp);
   memcpy(temp, &w[15], 5);
   temp[6]=0;
   station=atoi(temp);
}

void CSaleItem::SetTimestamp(BhDateTime& dt)
{
   timestamp=dt;
}

void CSaleItem::GetTimestamp(BhTimestamp *ts)
{
   ts->flags=14;
   ts->year=timestamp.Year();
   ts->month=timestamp.Month();
   ts->date=timestamp.Day();
   ts->hour=timestamp.Hour();
   ts->minute=timestamp.Minute();
   ts->second=timestamp.Second();
}

const BhDateTime& CSaleItem::GetTimestamp()
{
   return timestamp;
}


}
