/*
cservsideproduct.cpp 

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include "ctransitems.h"

namespace bhpos{

CServSideProduct::CServSideProduct() 
{
   ID=0;
   bAvailable=false;
   price=0.0;
   printerID=0;
}

CServSideProduct::CServSideProduct(CServSideProduct const& t)
{
   ID=t.ID;
   name=t.name;
   description=t.description;
   bAvailable=t.bAvailable;
   price=t.price;
   printerID=t.printerID;
   ReceiptText=t.ReceiptText;
}

CServSideProduct::CServSideProduct(const int tn)
{
	ID=tn;
   bAvailable=false;
   price=0.0;
   printerID=0;
}

CServSideProduct::CServSideProduct(const int t, const char *n, const char *d, const char *r,int pid, double p)
{
   ID=t;
   name=n;
   description=d;
   bAvailable=false;
   price=p;
   printerID=pid;
   ReceiptText=r;
}

CServSideProduct::~CServSideProduct()
{
}

CServSideProduct &CServSideProduct::operator=(CServSideProduct const& t)
{
   this->ID=t.ID;
   this->name=t.name;
   this->description=t.description;
   this->bAvailable=t.bAvailable;
   this->price=t.price;
   this->printerID=t.printerID;
   this->ReceiptText=t.ReceiptText;
   
	return *this;
}

bool CServSideProduct::operator==(CServSideProduct const& t)
{
   if(ID==t.ID) return true;
   return false;
}

bool CServSideProduct::operator!=(CServSideProduct const& t)
{
	if(ID!=t.ID) return true;
   return false;
}

int CServSideProduct::AddOption(CServSideProductOption& po)
{
   options.push_back(po);
   return options.size();
}

}
