/*
cserversideproductoption.cpp - a transaction shared library.

Copyright (C) 2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include "ctransitems.h"

namespace bhpos{

CServSideProductOption::CServSideProductOption() 
{
   ID=0;
   description[0]=0;
   ReceiptText[0]=0;
}

CServSideProductOption::CServSideProductOption(CServSideProductOption const& t)
{
   ID=t.ID;
   strcpy(description, t.description);
   strcpy(ReceiptText, t.ReceiptText);
}

CServSideProductOption::CServSideProductOption(const int tn)
{
	ID=tn;
   description[0]=0;
   ReceiptText[0]=0;
}

CServSideProductOption::CServSideProductOption(const int tn, const char *d, const char *r)
{
	ID=tn;
   strncpy(description, d, 63);
   strncpy(ReceiptText, r, 32);
}

CServSideProductOption::~CServSideProductOption()
{
}

CServSideProductOption &CServSideProductOption::operator=(CServSideProductOption const& t)
{
   this->ID=t.ID;
   strcpy(this->description, t.description);
   strcpy(this->ReceiptText, t.ReceiptText);
   
	return *this;
}

bool CServSideProductOption::operator==(CServSideProductOption const& t)
{
   if(ID==t.ID) return true;
   return false;
}

bool CServSideProductOption::operator!=(CServSideProductOption const& t)
{
	if(ID!=t.ID) return true;
   return false;
}

}
