/*
cservsidetarget.cpp - a transaction shared library.

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include "ctransitems.h"

namespace bhpos{

CServSideTarget::CServSideTarget() 
{
   ID=0;
   capacity=0;
   current=0;
   status=BHTARGET_STATUS_UNKNOWN;
   userID=0;
}

CServSideTarget::CServSideTarget(CServSideTarget const& t)
{
   ID=t.ID;
   name=t.name;
   capacity=t.capacity;
   current=t.current;
   status=t.status;
   userID=t.userID;
}

CServSideTarget::CServSideTarget(const int tn)
{
	ID=tn;
   capacity=0;
   current=0;
   status=BHTARGET_STATUS_UNKNOWN;
   userID=0;
}

CServSideTarget::CServSideTarget(const int tn, const char *n, const int c) 
{
   ID=tn;
	name=n;
	userID=0;
	capacity=c;
   current=0;
   status=BHTARGET_STATUS_UNKNOWN;
}

CServSideTarget::~CServSideTarget()
{
}

CServSideTarget &CServSideTarget::operator=(CServSideTarget const& t)
{
   this->ID=t.ID;
   this->name=t.name;
   this->capacity=t.capacity;
   this->current=t.current;
   this->status=t.status;
   this->userID=t.userID;
   
	return *this;
}

bool CServSideTarget::operator==(CServSideTarget const& t)
{
   if(ID==t.ID) return true;
   return false;
}

bool CServSideTarget::operator!=(CServSideTarget const& t)
{
	if(ID!=t.ID) return true;
   return false;
}

void CServSideTarget::SetStatus(BhTargetStatus s)
{
	status=s;
}

BhTargetStatus  CServSideTarget::GetStatus()
{
	return status;
}

}
