/*
cserversidetrans.cpp - a transaction shared library.

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include "ctransitems.h"

namespace bhpos{

CServSideTrans::CServSideTrans() : CTransItems()
{
   bAll=false;
   creatorID=0;
   userID=0;
   stationID=0;
   targetID=0;
   languageID=0;
   interfaceID=0;
   sstatus=BHSSTS_NUM_PICKEDUP;
}

CServSideTrans::CServSideTrans(CServSideTrans const& t)
{
   name=t.name;
   targetname=t.targetname;
   bAll=t.bAll;
   creatorID=t.creatorID;
	userID=t.userID;
	stationID=t.stationID;
	targetID=t.targetID;
	languageID=t.languageID;
	interfaceID=t.interfaceID;
   sstatus=t.sstatus;
   
	status=t.status;
   discount_type=t.discount_type;
	ID=t.ID;
	numunknown=t.numunknown;
   numprice==t.numprice;
	numreturn=t.numreturn;
   numlayby=t.numlayby;
   numrental=t.numrental;
   numephemeral=t.numephemeral;
	
	total_items=t.total_items;
	total=t.total;
	total_tendered=t.total_tendered;
	cash_tendered=t.cash_tendered;
	cash_change=t.cash_change;
   discount_margin=t.discount_margin;
	total_discount=t.total_discount;
	total_tax=t.total_tax;
	sub_total=t.sub_total;
	total_return=t.total_return;
	total_rental=t.total_rental;
   total_layby=t.total_layby;
   layby_deposit=t.layby_deposit;
   rental_deposit=t.rental_deposit;
	
	items=t.items;
	p_items=t.p_items;
}

CServSideTrans::CServSideTrans(const int tn)  : CTransItems(tn)
{
   bAll=false;
   creatorID=0;
	userID=0;
	stationID=0;
	targetID=0;
	languageID=0;
	interfaceID=0;
   sstatus=BHSSTS_NUM_PICKEDUP;
}

CServSideTrans::CServSideTrans(const int tn,const int pid, const int uid)  : CTransItems(tn)
{
   bAll=false;
   creatorID=uid;
	userID=uid;
	stationID=pid;
	targetID=0;
	languageID=0;
	interfaceID=0;
   sstatus=BHSSTS_NUM_PICKEDUP;
}

CServSideTrans::~CServSideTrans()
{
	items.clear();
	p_items.clear();
}

CServSideTrans &CServSideTrans::operator=(CServSideTrans const& t)
{
   this->name=t.name;
   this->targetname=t.targetname;
   this->bAll=t.bAll;
   this->creatorID=t.creatorID;
	this->userID=t.userID;
	this->stationID=t.stationID;
	this->targetID=t.targetID;
	this->languageID=t.languageID;
	this->interfaceID=t.interfaceID;
   this->sstatus=t.sstatus;
   
	this->status=t.status;
   this->discount_type=t.discount_type;
	this->ID=t.ID;
	this->numunknown=t.numunknown;
   this->numprice=t.numprice;
	this->numreturn=t.numreturn;
   this->numlayby=t.numlayby;
   this->numrental=t.numrental;
	this->numephemeral=t.numephemeral;
	
	this->total_items=t.total_items;
	this->total=t.total;
	this->total_tendered=t.total_tendered;
	this->cash_tendered=t.cash_tendered;
	this->cash_change=t.cash_change;
   this->discount_margin=t.discount_margin;
	this->total_discount=t.total_discount;
	this->total_tax=t.total_tax;
	this->sub_total=t.sub_total;
	this->total_return=t.total_return;
	this->total_rental=t.total_return;
   this->total_layby=t.total_layby;
   this->layby_deposit=t.layby_deposit;
   this->rental_deposit=t.rental_deposit;
	
	this->items=t.items;
	this->p_items=t.p_items;
	
	return *this;
}

CServSideTrans *CServSideTrans::operator&()
{
   return this;
}

bool CServSideTrans::operator==(CServSideTrans const& t)
{
   if(bAll){
      if(ID==t.ID) return true;
      return false;
   }
   else{
	   if(ID==t.ID && creatorID==t.creatorID) return true;
      return false;
   }
}
bool CServSideTrans::operator!=(CServSideTrans const& t)
{
	if(bAll){
      if(ID!=t.ID) return true;
      return false;
   }
   else{
	   if(ID!=t.ID || creatorID!=t.creatorID) return true;
      return false;
   }
	
	return false;
}

}
