/*
cservsidetransstack.cpp - a server side transaction stack.

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include "ctransitems.h"

namespace bhpos{

CServSideTransStack::CServSideTransStack()
{
}

CServSideTransStack::CServSideTransStack(CServSideTransStack const& ssi)
{
}

CServSideTransStack::~CServSideTransStack()
{
	stack.clear();
}
/*
bool CServSideTransStack::operator==(CServSideTransStack const& ssi)
{
   
   return false;
}

void CServSideTransStack::operator=(CServSideTransStack const& ssi)
{
}

int CServSideTransStack::operator-=(CServSideTransStack const& ssi)
{
   return 0;
}

int CServSideTransStack::operator+=(CServSideTransStack const& ssi)
{
   return 0;
}*/
int CServSideTransStack::Add(int tid, int pid, int uid)
{
   CServSideTrans n(tid, pid, uid);
   stack.push_back(n);
   
   return 0;
}

int CServSideTransStack::NumTransactions(BhSSTSNumber type, int)
{
   if(stack.empty()) return 0;
   
   if(type==BHSSTS_NUM_ALL) return stack.size();
   
   int            ret=0;
   BhSSTSNumber   s;
   std::list<CServSideTrans>::iterator iter=stack.begin();
   
   while(iter!=stack.end()){
      while(iter!=stack.end()){
      s=iter->GetSStatus();
	   if(s==type) ret++;
      iter++;
   }
   }
   return ret;
}

//int CServSideTransStack::List(BhSSTSNumber type, int uid, char *tnum, char *target, int *nitems)
int CServSideTransStack::List(BhSSTSNumber type, int uid, BhTransRoverList *rlist)
{
	std::list<CServSideTrans>::iterator iter=stack.begin();
   BhSSTSNumber          s;
   int                   n=0;
   BhTransRoverListItem *ritem=rlist->item;
   
   if(stack.empty()) return 0;
   if(type==BHSSTS_NUM_ALL) return stack.size();
	
   while(iter!=stack.end()){
      s=iter->GetSStatus();
	   if(s==type){
         ritem->ID=iter->GetID();
         ritem->status=iter->GetSStatus();
         ritem->userID=iter->GetUserID();
         ritem-> num_items=iter->NumAllItems();
         strcpy(ritem->name, iter->GetName().data());
         strcpy(ritem->target, iter->GetTargetName().data());
         ritem->amount=iter->GetNumber(BHNUM_SUBTOTAL);

         rlist->num_items++;
         n++;
         ritem++;
      }
      iter++;
   }
   return n;
}

int CServSideTransStack::Pop(CServSideTrans& ti)
{
	ti=stack.back();
	stack.pop_back();
	return 0;
}

int CServSideTransStack::Push(CServSideTrans& ti)
{
	stack.push_back(ti);
	return 0;
}   

int CServSideTransStack::Head(CServSideTrans& ti)
{
   ti=stack.front();
   return 0;
}

int CServSideTransStack::Tail(CServSideTrans& ti)
{
   ti=stack.back();
   return 0;
}

int CServSideTransStack::Next(CServSideTrans&)
{
   return 0;
}

int CServSideTransStack::Prev(CServSideTrans&)
{
   return 0;
}

int CServSideTransStack::AddTarget(CServSideTarget& t)
{
	targets.push_back(t);
	return 0;
}

int CServSideTransStack::AddMenu(CServSideMenu& m)
{
   menu=m;
}

}
