/*
ctrans.cpp - a transaction shared library.

Copyright (C) 2001 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <pthread.h>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
#include "ctransitems.h"

namespace bhpos{

CTransItems::CTransItems()
{
	status=BHTRANS_STATUS_IDLE;
   discount_type=BHTRANS_DISCOUNT_NONE;
   type=BHTRANSACTION_TYPE_NONE;
   //memset(&timestamp, 0, sizeof(BhDateTime ));
	ID=0;
   nameID=1;
	numunknown=0;
   numprice=0;
	numreturn=0;
   numlayby=0;
   numrental=0;
   numephemeral=0;
   numreturnreasons=0;
   numredemption=0;
   currencyRound=BHTRANS_ROUND_NONE;
   roundvalue=0.0;
   userid=0;
   strcpy(userName, "");
   
	total_items=0.0;
	sub_total=0.0;
	total=0.0;
   discount_margin=0.0;
	total_discount=0.0;
	total_tax=0.0;
	total_tendered=0.0;
	cash_tendered=0.0;
	cash_change=0.0;
	total_return=0.0;
	total_rental=0.0;
   total_layby=0.0;
   layby_deposit=0.0;
   rental_deposit=0.0;
}
CTransItems::CTransItems(CTransItems const& t)
{
	status=t.status;
   discount_type=t.discount_type;
   type=t.type;
   timestamp=t.timestamp;
	ID=t.ID;
   nameID=t.nameID;
	numunknown=t.numunknown;
   numprice==t.numprice;
	numreturn=t.numreturn;
   numlayby=t.numlayby;
   numrental=t.numrental;
   numephemeral=t.numephemeral;
   numreturnreasons=t.numreturnreasons;
   numredemption=t.numredemption;
   currencyRound=t.currencyRound;
   roundvalue=t.roundvalue;
   userid=t.userid;
   strcpy(userName, t.userName);
	
	total_items=t.total_items;
	total=t.total;
	total_tendered=t.total_tendered;
	cash_tendered=t.cash_tendered;
	cash_change=t.cash_change;
   discount_margin=t.discount_margin;
	total_discount=t.total_discount;
	total_tax=t.total_tax;
	sub_total=t.sub_total;
	total_return=t.total_return;
	total_rental=t.total_rental;
   total_layby=t.total_layby;
   layby_deposit=t.layby_deposit;
   rental_deposit=t.rental_deposit;
	
	items=t.items;
	p_items=t.p_items;
   rr_items=t.rr_items;
}

CTransItems::CTransItems(const int tid)
{
	status=BHTRANS_STATUS_IDLE;
   discount_type=BHTRANS_DISCOUNT_NONE;
   type=BHTRANSACTION_TYPE_NONE;
	ID=tid;
   nameID=1;
	numunknown=0;
   numprice=0;
	numreturn=0;
   numlayby=0;
   numrental=0;
   numephemeral=0;
   numreturnreasons=0;
   numredemption=0;
   currencyRound=BHTRANS_ROUND_NONE;
   roundvalue=0.0;
   userid=0;
   strcpy(userName, "");
   
   total_items=0.0;
   total=0.0;
	sub_total=0.0;
   discount_margin=0.0;
	total_discount=0.0;
	total_tax=0.0;
	total_tendered=0.0;
	cash_tendered=0.0;
	cash_change=0.0;
	total_return=0.0;
	total_rental=0.0;
   total_layby=0.0;
   layby_deposit=0.0;
   rental_deposit=0.0;
}

CTransItems::~CTransItems()
{
	items.clear();
	p_items.clear();
   rr_items.clear();
}

CTransItems &CTransItems::operator=(const CTransItems& t)
{
	this->status=t.status;
   this->discount_type=t.discount_type;
   this->type=t.type;
   this->timestamp=t.timestamp;
	this->ID=t.ID;
   this->nameID=t.nameID;
	this->numunknown=t.numunknown;
   this->numprice=t.numprice;
	this->numreturn=t.numreturn;
   this->numlayby=t.numlayby;
   this->numrental=t.numrental;
	this->numephemeral=t.numephemeral;
   this->numreturnreasons=t.numreturnreasons;
   this->numredemption=t.numredemption;
   this->currencyRound=t.currencyRound;
   this->roundvalue=t.roundvalue;
   this->userid=t.userid;
   strcpy(this->userName, t.userName);
	
	this->total_items=t.total_items;
	this->total=t.total;
	this->total_tendered=t.total_tendered;
	this->cash_tendered=t.cash_tendered;
	this->cash_change=t.cash_change;
   this->discount_margin=t.discount_margin;
	this->total_discount=t.total_discount;
	this->total_tax=t.total_tax;
	this->sub_total=t.sub_total;
	this->total_return=t.total_return;
	this->total_rental=t.total_return;
   this->total_layby=t.total_layby;
   this->layby_deposit=t.layby_deposit;
   this->rental_deposit=t.rental_deposit;
	
	this->items=t.items;
	this->p_items=t.p_items;
   this->rr_items=t.rr_items;
	
	return *this;
}
/*
CTransItems *CTransItems::operator&()
{
   return this;
}
*/
bool CTransItems::operator==(const CTransItems& t)
{
	if(ID==t.ID) return true;
	
	return false;
}

bool CTransItems::operator==(const int tid)
{
	if(ID==tid) return true;
	
	return false;
}
bool CTransItems::operator!=(const CTransItems& t)
{
	if(ID!=t.ID) return true;
	
	return false;
}

bool CTransItems::operator!=(const int tid)
{
	if(ID!=tid) return true;
	return false;
}

bool CTransItems::operator<(const CTransItems& t)
{
	if(items.size() < t.items.size()) return true;
	return false;
}

int CTransItems::operator+=(CTransItems& t)
{
	items.splice(items.begin(), t.items, t.items.begin(), t.items.end());
	p_items.splice(p_items.begin(), t.p_items, t.p_items.begin(), t.p_items.end());

   numunknown+=t.numunknown;
   numprice+=t.numprice;
	numreturn+=t.numreturn;
   numlayby+=t.numlayby;
   numrental+=t.numrental;
   numephemeral+=t.numephemeral;
   numreturnreasons+=t.numreturnreasons;
   numredemption+=t.numredemption;
   currencyRound=t.currencyRound;
   roundvalue=t.roundvalue;
   
   total_items+=t.total_items;
   total+=t.total;
   sub_total+=t.sub_total;
   discount_margin+=t.discount_margin;
	total_discount+=t.total_discount;
	total_tax+=total_tax;
	total_tendered+=t.total_tendered;
	cash_tendered+=t.cash_tendered;
	cash_change+=t.cash_change;
	total_return+=t.total_return;
	total_rental+=t.total_rental;
   total_layby+=t.total_layby;
   layby_deposit+=t.layby_deposit;
   rental_deposit+=t.rental_deposit;
	
	return 0;
}

///////////////////////////////////////////////////
//
//	Remove repeated PLUs, and increment quantity

int CTransItems::Rationalize()
{
	/*
	std::list<CSaleItem>::iterator iter, biter;
	iter=items.begin();
	// go through whole list
	while(iter!=items.end()){
	   // run through a look and see pass - for later processing
	   biter=iter + 1;
		while(biter!=items.end()){
			if(*iter==*biter){
				iter->SetQuantity(iter->GetQuantity() + biter->GetQuantity());
			}
			biter++;
		}
		// killer pass
		while(biter!=items.end()){
			if(*iter==*biter)  items.erase(biter);
		   biter++;
		}
		iter++;
	}*/
	return 0;
}

void CTransItems::SetTimestamp(BhDateTime& dt)
{
   timestamp=dt;
}

void CTransItems::GetTimestamp(BhTimestamp *ts)
{
   ts->flags=14;
   ts->year=timestamp.Year();
   ts->month=timestamp.Month();
   ts->date=timestamp.Day();
   ts->hour=timestamp.Hour();
   ts->minute=timestamp.Minute();
   ts->second=timestamp.Second();
}

const BhDateTime& CTransItems::GetTimestamp()
{
   return timestamp;
}

const double CTransItems::GetNumber(BhTransNumber who)
{
	switch(who){
	case BHNUM_SUBTOTAL: return sub_total;
	case BHNUM_TOTALITEMS: return total_items;
	case BHNUM_TOTAL: return total;
	case BHNUM_DISCOUNT: return total_discount;
	case BHNUM_TAX: return total_tax;
	case BHNUM_TENDERED: return cash_tendered;
	case BHNUM_CHANGE: return cash_change;
	case BHNUM_TOTALTENDERED: return total_tendered;
	case BHNUM_CASHTENDERED: return cash_tendered;
	case BHNUM_TOTALRETURN: return total_return;
	case BHNUM_LAYBYTOTAL: return total_layby;
   case BHNUM_LAYBYDEPOSIT: return layby_deposit;
   case BHNUM_RENTALTOTAL: return total_rental;
   case BHNUM_RENTALDEPOSIT: return rental_deposit;
   case BHNUM_ROUNDUNIT: return roundvalue;
	}
	return 0.0f;
}

void CTransItems::SetNumber(BhTransNumber who, double v)
{
	switch(who){
	case BHNUM_SUBTOTAL: sub_total=v; break;
	case BHNUM_TOTALITEMS: total_items=v; break;
	case BHNUM_TOTAL: total=v; break;
	case BHNUM_DISCOUNT: total_discount=v; break;
	case BHNUM_TAX: total_tax=v; break;
	case BHNUM_TENDERED: cash_tendered=v; break;
	case BHNUM_CHANGE: cash_change=v; break;
	case BHNUM_TOTALTENDERED: total_tendered=v; break;
	case BHNUM_CASHTENDERED: cash_tendered=v; break;
	case BHNUM_TOTALRETURN: total_return=v; break;
	case BHNUM_LAYBYTOTAL: total_layby=v; break;
   case BHNUM_LAYBYDEPOSIT: layby_deposit=v; break;
   case BHNUM_RENTALTOTAL: total_rental=v; break;
   case BHNUM_RENTALDEPOSIT: rental_deposit=v; break;
   case BHNUM_ROUNDUNIT: roundvalue=v; break;
	}
}

void CTransItems::SetUserName(char *uname)
{
   if(!uname) return;
   strncpy(userName, uname, 32);
}

int CTransItems::AddReturnReason(int r)
{
   std::list<CReturnReason>::iterator iter=find(rr_items.begin(), rr_items.end(), r);
   
   if(iter==rr_items.end()){
      CReturnReason rr(r, 1);
      rr_items.push_back(rr);
      return 1;
   }
   else{
      *iter++;
   }
   return 0;
}

int CTransItems::RemoveReturnReason(int r)
{
   std::list<CReturnReason>::iterator iter=find(rr_items.begin(), rr_items.end(), r);
   
   if(iter!=rr_items.end()){
      if(*iter-- == 0){
         rr_items.erase(iter);
         return 1;
      }
   }
   return 0;
}

// this only works in singular return reasons trans...
const int CTransItems::GetReturnReason()
{
   if(rr_items.empty()) return 0;
   std::list<CReturnReason>::iterator iter=rr_items.begin();

   iter++;
   return iter->GetReason();
}

bool CTransItems::Update(int n, CSaleItem& si)
{
   std::list<CSaleItem>::iterator i=items.begin();
   
   if(items.empty()) return true;
   
   int x=n;

	while(x){ i++; x--; }
	if(i==items.end()) return true;
   if(*i!=si) return true;

	if(i->GetType()==BHSI_SITYPE_UPLU){
      numunknown--;
	   total_items-=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice--;
	   total_items-=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn--;
      total_discount-=i->GetTotalDiscount();
      total_tax+=(i->GetTotal()*i->GetTax());
      total_return-=i->GetSubTotal();
      if(RemoveReturnReason(i->GetReason())){
         numreturnreasons--;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      numlayby--;
      total_layby-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      numrental--;
      total_rental-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral--;
      total_items-=i->GetTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount-=i->GetTotalDiscount();
  		total_tax-=(i->GetTotal()*i->GetTax());
	   total_items-=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption--;
   }

   *i=si;
		
	if(si.GetType()==BHSI_SITYPE_UPLU){
	   numunknown++;
	   total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
	}
   else if(si.GetType()==BHSI_SITYPE_PRICE){
      numprice++;
      total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
   }
	else if(si.GetType()==BHSI_SITYPE_RETURN){
      numreturn++;
      total_discount+=i->GetTotalDiscount();
      total_return+=si.GetSubTotal();
      total_tax-=(si.GetTotal()*si.GetTax());
      if(AddReturnReason(i->GetReason())){
         numreturnreasons++;
      }
   }
   else if(si.GetType()==BHSI_SITYPE_LAYBY){
      if(si.GetDeposit()!=0.0){
         layby_deposit+=si.GetTotal()*si.GetDeposit();
      }
      numlayby++;
      total_layby+=si.GetSubTotal();
   }
   else if(si.GetType()==BHSI_SITYPE_RENTAL){
      if(si.GetDeposit()!=0.0){
         rental_deposit+=(si.GetTotal()*si.GetDeposit());
      }
      numrental++;
      total_rental+=si.GetSubTotal();
   }
   else if(si.GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral++;
      total_items++;
   }
   else if(si.GetType()==BHSI_SITYPE_PLU){
      total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
   }
   
   if(si.GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption++;
   }
   
   sub_total=total_items - total_return;
   total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
	return false;
}

bool CTransItems::Update(BhTransEditType t, int n, CSaleItem& si)
{
   std::list<CSaleItem>::iterator i=items.begin();
   
   if(items.empty()) return true;
   
   int x=n;

	while(x){ i++; x--; }
	if(i==items.end()) return true;
   if(*i!=si) return true;

	if(i->GetType()==BHSI_SITYPE_UPLU){
      numunknown--;
	   total_items-=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice--;
	   total_items-=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn--;
      total_discount-=i->GetTotalDiscount();
      total_tax+=(i->GetTotal()*i->GetTax());
      total_return-=i->GetSubTotal();
      if(RemoveReturnReason(i->GetReason())){
         numreturnreasons--;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      numlayby--;
      total_layby-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      numrental--;
      total_rental-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral--;
      total_items-=i->GetTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount-=i->GetTotalDiscount();
  		total_tax-=(i->GetTotal()*i->GetTax());
	   total_items-=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption--;
   }

   if(t==BHTRANSEDITTYPE_QTY){
      if(si.GetQuantity()==0){
         items.erase(i);
         sub_total=total_items - total_return;
         total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
         return false;
      }
      i->SetQuantity(si.GetQuantity());
   }
      
	if(i->GetType()==BHSI_SITYPE_UPLU){
	   numunknown++;
	   total_discount+=i->GetTotalDiscount();
  		total_tax+=(i->GetTotal()*i->GetTax());
	   total_items+=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice++;
      total_discount+=i->GetTotalDiscount();
  		total_tax+=(i->GetTotal()*i->GetTax());
	   total_items+=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn++;
      total_discount+=i->GetTotalDiscount();
      total_return+=i->GetSubTotal();
      total_tax-=(i->GetTotal()*i->GetTax());
      if(AddReturnReason(i->GetReason())){
         numreturnreasons++;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      if(i->GetDeposit()!=0.0){
         layby_deposit+=i->GetTotal()*i->GetDeposit();
      }
      numlayby++;
      total_layby+=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      if(i->GetDeposit()!=0.0){
         rental_deposit+=(i->GetTotal()*i->GetDeposit());
      }
      numrental++;
      total_rental+=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral++;
      total_items++;
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount+=i->GetTotalDiscount();
  		total_tax+=(i->GetTotal()*i->GetTax());
	   total_items+=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption++;
   }
   
   sub_total=total_items - total_return;
   total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
   //printf("Update: 3\nt:%f\nt:%f\n", sub_total, total);
	return false;
}

bool CTransItems::Update(CSaleItem& si)
{
	std::list<CSaleItem>::iterator i=items.end();
   
   if(items.empty()) return true;
   i--;
   if(*i!=si){
      while(i!=items.begin()){
         if(*i==si) break;
         i--;
      }
      if(i==items.begin()) return true;
   }
	if(i->GetType()==BHSI_SITYPE_UPLU){
      numunknown--;
	   total_items-=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice--;
	   total_items-=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn--;
      total_discount-=i->GetTotalDiscount();
      total_tax+=(i->GetTotal()*i->GetTax());
      total_return-=i->GetSubTotal();
      if(RemoveReturnReason(i->GetReason())){
         numreturnreasons--;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      numlayby--;
      total_layby-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      numrental--;
      total_rental-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral--;
      total_items-=i->GetTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount-=i->GetTotalDiscount();
  		total_tax-=(i->GetTotal()*i->GetTax());
	   total_items-=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption--;
   }

   *i=si;
		
	if(si.GetType()==BHSI_SITYPE_UPLU){
	   numunknown++;
	   total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
	}
   else if(si.GetType()==BHSI_SITYPE_PRICE){
      numprice++;
      total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
   }
	else if(si.GetType()==BHSI_SITYPE_RETURN){
      numreturn++;
      total_discount+=i->GetTotalDiscount();
      total_return+=si.GetSubTotal();
      total_tax-=(si.GetTotal()*si.GetTax());
      if(AddReturnReason(i->GetReason())){
         numreturnreasons++;
      }
   }
   else if(si.GetType()==BHSI_SITYPE_LAYBY){
      if(si.GetDeposit()!=0.0){
         layby_deposit+=si.GetTotal()*si.GetDeposit();
      }
      numlayby++;
      total_layby+=si.GetSubTotal();
   }
   else if(si.GetType()==BHSI_SITYPE_RENTAL){
      if(si.GetDeposit()!=0.0){
         rental_deposit+=(si.GetTotal()*si.GetDeposit());
      }
      numrental++;
      total_rental+=si.GetSubTotal();
   }
   else if(si.GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral++;
      total_items++;
   }
   else if(si.GetType()==BHSI_SITYPE_PLU){
      total_discount+=si.GetTotalDiscount();
  		total_tax+=(si.GetTotal()*si.GetTax());
	   total_items+=si.GetSubTotal();
   }
   
   if(si.GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption++;
   }
   
   sub_total=total_items - total_return;
   total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));

	return false;
}

bool CTransItems::Update(CPayItem& pi)
{
	std::list<CPayItem>::iterator i=find(p_items.begin(), p_items.end(), pi);
	if(i!=p_items.end()){
	   total_tendered-=i->GetAmount();
	   if(i->GetID()==PTYPE_CASH){
	      if((total_tendered - total) >= 0.0){
   			cash_change-=(total_tendered - total);
   		}
		}
		total_tendered+=pi.GetAmount();
		if(pi.GetID()==PTYPE_CASH){
		   if((total_tendered - total) >= 0.0){
   		   cash_change=total_tendered - total;
   		}
		}  
	   
		*i=pi;
		return true;
	}

	return false;
}

int CTransItems::UpdateAll()
{
	CSaleItem si;
	CPayItem  pi;
	std::list<CSaleItem>::iterator iter;
	std::list<CPayItem>::iterator  piter;
	int cflag=0;
	
	numunknown=0;
	numreturn=0;
   numlayby=0;
   numrental=0;
   numephemeral=0;
   numreturnreasons=0;
   numredemption=0;
   //currencyRound=BHTRANS_ROUND_NONE;
   //roundvalue=0.0;
   
   sub_total=0.0;
   total=0.0;
   total_items=0.0;
   discount_margin=0.0;
	total_discount=0.0;
	total_tax=0.0;
	total_tendered=0.0;
	cash_tendered=0.0;
	cash_change=0.0;
	total_return=0.0;
   total_layby=0.0;
   layby_deposit=0.0;
   rental_deposit=0.0;
	
	for(iter=items.begin(); iter!=items.end(); iter++){ 
		si=*iter;
		
		if(si.GetType()==BHSI_SITYPE_UPLU){
		   numunknown++;
		   total_discount+=si.GetTotalDiscount();
   		total_tax+=(si.GetTotal()*si.GetTax());
		   total_items+=si.GetSubTotal();
		}
      if(si.GetType()==BHSI_SITYPE_PRICE){
		   numprice++;
		   total_discount+=si.GetTotalDiscount();
   		total_tax+=(si.GetTotal()*si.GetTax());
		   total_items+=si.GetSubTotal();
		}
		else if(si.GetType()==BHSI_SITYPE_RETURN){
	      numreturn++;
         total_discount-=si.GetTotalDiscount();
	      total_return+=si.GetSubTotal();
	      total_tax-=(si.GetTotal()*si.GetTax());
         if(AddReturnReason(si.GetReason())){
            numreturnreasons++;
         }
	   }
	   else if(si.GetType()==BHSI_SITYPE_LAYBY){
	      if(si.GetDeposit()!=0.0){
	         layby_deposit+=si.GetTotal()*si.GetDeposit();
	      }
	      numlayby++;
	      total_layby+=si.GetSubTotal();
	   }
	   else if(si.GetType()==BHSI_SITYPE_RENTAL){
	      if(si.GetDeposit()!=0.0){
	         rental_deposit+=si.GetTotal()*si.GetDeposit();
	      }
	      numrental++;
	      total_rental+=si.GetSubTotal();
	   }
	   else if(si.GetType()==BHSI_SITYPE_EPHEMERAL){
	      numephemeral++;
	      total_items+=si.GetSubTotal();
	   }
	   else if(si.GetType()==BHSI_SITYPE_PLU){
	      total_discount+=si.GetTotalDiscount();
   		total_tax+=(si.GetTotal()*si.GetTax());
		   total_items+=si.GetSubTotal();
	   }
      
      if(si.GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
         numredemption++;
      }
	}
	sub_total=total_items - total_return;
	total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
	//printf("ctrans: total_items: %0.2f\n subtotal: %0.2f\n", total_items, sub_total);
	for(piter=p_items.begin(); piter!=p_items.end(); piter++){ 
		pi=*piter;
   	total_tendered+=pi.GetAmount();
   	if(pi.GetID()==PTYPE_CASH){
   	   cash_tendered+=pi.GetAmount();
   	   cflag=1;
   	}
	}
	if(cflag){
	   if((total_tendered - sub_total) >= 0.0){
			cash_change=total_tendered - total;
		}
   }
	
	return 0;
}

const CSaleItem& CTransItems::CurrItem(int seeker)
{
	static CSaleItem si;
	std::list<CSaleItem>::iterator iter;
	
	if(seeker!=0){
		if(seeker>0){
			iter=items.begin();
			seeker--;
			while(seeker){ 
				iter++;
				seeker--;
			}
		}
		else{
			iter=items.end();
			seeker=-(seeker);
			while(seeker){ 
				iter--;
				seeker++;
			}
		}
	}
	else{
		iter=items.end();
		iter--;
	}
	si=*iter;
	
	return si;
}

int CTransItems::GetItem(int i, CSaleItem& si)
{
	if(items.empty()) return 1;
	
	int x=i;

	std::list<CSaleItem>::iterator iter=items.begin();
	while(x){ 
      iter++; 
      x--; 
      if(iter==items.end()) return 2;
   }
	if(iter==items.end()) return 3;
	si=*iter;
	
	return 0;
}
int CTransItems::GetItem(CSaleItem& si)
{
   if(items.empty()) return 1;

	std::list<CSaleItem>::iterator iter=find(items.begin(), items.end(), si);
	if(iter==items.end()) return 2;
	si=*iter;

	return 0;
}

int CTransItems::Add(CSaleItem *si, bool bUpdate)
{
   if(si->GetType()==BHSI_SITYPE_UPLU){
	   numunknown++;
	   if(bUpdate){
   	   total_discount+=si->GetTotalDiscount();
      	total_tax+=(si->GetTotal()*si->GetTax());
   		total_items+=si->GetSubTotal();
      }
	}
   else if(si->GetType()==BHSI_SITYPE_PRICE){
      numprice++;
      if(bUpdate){
         total_discount+=si->GetTotalDiscount();
      	total_tax+=(si->GetTotal()*si->GetTax());
   		total_items+=si->GetSubTotal();
      }
   }
	else if(si->GetType()==BHSI_SITYPE_RETURN){
      numreturn++;
      if(bUpdate){
         total_return+=si->GetTotal();
         total_discount-=si->GetTotalDiscount();
         total_tax-=(si->GetTotal()*si->GetTax());
         if(AddReturnReason(si->GetReason())){
            numreturnreasons++;
         }
      }
   }
   else if(si->GetType()==BHSI_SITYPE_LAYBY){
      if(bUpdate){
         if(si->GetDeposit()!=0.0){
	         layby_deposit+=si->GetTotal()*si->GetDeposit();
   	   }
   	   total_layby+=si->GetSubTotal();
   	} 
      numlayby++;
   }
   else if(si->GetType()==BHSI_SITYPE_RENTAL){
      if(bUpdate){
         if(si->GetDeposit()!=0.0){
	         rental_deposit+=si->GetTotal()*si->GetDeposit();
   	   }
         total_rental+=si->GetSubTotal();
      }
      numrental++;
   }
   else if(si->GetType()==BHSI_SITYPE_EPHEMERAL){
	   numephemeral++;
	   total_items+=si->GetTotal();
	}
   else if(si->GetType()==BHSI_SITYPE_PLU){
      if(bUpdate){
         total_discount+=si->GetTotalDiscount();
   		total_tax+=(si->GetTotal()*si->GetTax());
	      total_items+=si->GetSubTotal();
	   }
   }
   
   if(si->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption++;
   }
   
	items.push_back(*si);
	if(bUpdate){
   	sub_total=total_items - total_return;
   	total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
   }

	return 0;
}

int CTransItems::Add(CSaleItem& si, bool bUpdate)
{
	if(si.GetType()==BHSI_SITYPE_UPLU){
	   numunknown++;
	   if(bUpdate){
   	   total_discount+=si.GetTotalDiscount();
      	total_tax+=(si.GetTotal()*si.GetTax());
   		total_items+=si.GetSubTotal();
      }
	}
   else if(si.GetType()==BHSI_SITYPE_PRICE){
      numprice++;
      if(bUpdate){
         total_discount+=si.GetTotalDiscount();
      	total_tax+=(si.GetTotal()*si.GetTax());
   		total_items+=si.GetSubTotal();
      }
   }
	else if(si.GetType()==BHSI_SITYPE_RETURN){
      numreturn++;
      if(bUpdate){
         total_return+=si.GetTotal();
         total_discount-=si.GetTotalDiscount();
         total_tax-=(si.GetTotal()*si.GetTax());
         if(AddReturnReason(si.GetReason())){
            numreturnreasons++;
         }
      }
   }
   else if(si.GetType()==BHSI_SITYPE_LAYBY){
      if(bUpdate){
         if(si.GetDeposit()!=0.0){
	         layby_deposit+=si.GetTotal()*si.GetDeposit();
   	   }
   	   total_layby+=si.GetSubTotal();
   	} 
      numlayby++;
   }
   else if(si.GetType()==BHSI_SITYPE_RENTAL){
      if(bUpdate){
         if(si.GetDeposit()!=0.0){
	         rental_deposit+=si.GetTotal()*si.GetDeposit();
   	   }
         total_rental+=si.GetSubTotal();
      }
      numrental++;
   }
   else if(si.GetType()==BHSI_SITYPE_EPHEMERAL){
	   numephemeral++;
	   total_items+=si.GetTotal();
	}
   else if(si.GetType()==BHSI_SITYPE_PLU){
      if(bUpdate){
         total_discount+=si.GetTotalDiscount();
   		total_tax+=(si.GetTotal()*si.GetTax());
	      total_items+=si.GetSubTotal();
	   }
   }
   
   if(si.GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption++;
   }
   
	items.push_back(si);
	if(bUpdate){
   	sub_total=total_items - total_return;
   	total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
   }

	return 0;
}

int CTransItems::Delete(int n)
{
	if(items.empty()) return 1;

	int x=n;
	std::list<CSaleItem>::iterator i=items.begin();
	
	while(x){ i++; x--;}
	if(i==items.end()) return 2;
      
	if(i->GetType()==BHSI_SITYPE_UPLU){
      numunknown--;
	   total_items-=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice--;
	   total_items-=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn--;
      total_discount-=i->GetTotalDiscount();
      total_tax+=(i->GetTotal()*i->GetTax());
      total_return-=i->GetSubTotal();
      if(RemoveReturnReason(i->GetReason())){
         numreturnreasons--;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      numlayby--;
      total_layby-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      numrental--;
      total_rental-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral--;
      total_items-=i->GetTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount-=i->GetTotalDiscount();
  		total_tax-=(i->GetTotal()*i->GetTax());
	   total_items-=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption--;
   }
   
   sub_total=total_items - total_return;
   total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
   
	items.erase(i);
	if(items.empty()) return 0;
	return 0;
}

int CTransItems::Delete(CSaleItem& si)
{
	std::list<CSaleItem>::iterator i=find(items.begin(), items.end(), si);
	
	if(i==items.end()) return 1;
   
   if(i->GetType()==BHSI_SITYPE_UPLU){
      numunknown--;
	   total_items-=i->GetSubTotal();
	}
   else if(i->GetType()==BHSI_SITYPE_PRICE){
      numprice--;
	   total_items-=i->GetSubTotal();
   }
	else if(i->GetType()==BHSI_SITYPE_RETURN){
      numreturn--;
      total_discount-=i->GetTotalDiscount();
      total_tax+=(i->GetTotal()*i->GetTax());
      total_return-=i->GetSubTotal();
      if(RemoveReturnReason(i->GetReason())){
         numreturnreasons--;
      }
   }
   else if(i->GetType()==BHSI_SITYPE_LAYBY){
      numlayby--;
      total_layby-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_RENTAL){
      numrental--;
      total_rental-=i->GetSubTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_EPHEMERAL){
      numephemeral--;
      total_items-=i->GetTotal();
   }
   else if(i->GetType()==BHSI_SITYPE_PLU){
      total_discount-=i->GetTotalDiscount();
  		total_tax-=(i->GetTotal()*i->GetTax());
	   total_items-=i->GetSubTotal();
   }
   
   if(i->GetDepositType()==BHSI_DEPOSIT_REDEMPTION){
      numredemption--;
   }
   
   sub_total=total_items - total_return;
   total=Round(sub_total+total_tax - (total_discount + rental_deposit + layby_deposit));
   
   items.erase(i);
	if(items.empty()) return 0;
	return 0;
}

int CTransItems::Pop(CSaleItem& si)
{
	if(items.empty()) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_PLU){
		while(iter->GetType()!=BHSI_SITYPE_PLU && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_PLU){		
		items.pop_front();
	}
	else{
	   return 0;
	}
	
	return 1;
}

int CTransItems::PopUnknown(CSaleItem& si)
{
	if(items.empty()) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_UPLU){
		while(iter->GetType()!=BHSI_SITYPE_UPLU && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_UPLU){
	   items.pop_front();
	}
	else{
	   return 0;
	}
   numunknown--;	
	
	return 1;
}

int CTransItems::PopPrice(CSaleItem& si)
{
	if(items.empty()) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_PRICE){
		while(iter->GetType()!=BHSI_SITYPE_PRICE && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_PRICE){
	   items.pop_front();
	}
	else{
	   return 0;
	}
   numprice--;	
	
	return 1;
}

int CTransItems::PopReturn(CSaleItem& si)
{
   if(items.empty()  || numreturn==0) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_RETURN){
		while(iter->GetType()!=BHSI_SITYPE_RETURN && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_RETURN){
	   items.pop_front();
	}
	else{
	   return 0;
	}
   numreturn--;

	return 1;
}
/*
int CTransItems::PopReturnwithReason(int r, CSaleItem& si)
{
   if(items.empty()  || numreturn==0) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_RETURN && iter->GetFlags()!=r){
		while(iter->GetType()!=BHSI_SITYPE_RETURN && iter->GetFlags()!=r && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_RETURN && iter->GetFlags()==r){
	   items.pop_front();
	}
	else{
	   return 0;
	}
   numreturn--;

	return 1;
}
*/
int CTransItems::PopRental(CSaleItem& si)
{
   if(items.empty() || numrental==0) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_RENTAL){
		while(iter->GetType()!=BHSI_SITYPE_RENTAL && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_RENTAL){
	   items.pop_front();
	}
	else{
	   return 0;
	}
   numrental--;

	return 1;
}

int CTransItems::PopLayby(CSaleItem& si)
{
   if(items.empty() || numlayby==0) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_LAYBY){
		while(iter->GetType()!=BHSI_SITYPE_LAYBY && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_LAYBY){
	   items.pop_front();
	}
	else{
	   return 0;
	}
	
   numlayby--;

	return 1;
}

int CTransItems::PopEphemeral(CSaleItem& si)
{
   if(items.empty()) return 0;

	std::list<CSaleItem>::iterator iter=items.begin();

	si=items.front();
	if(iter->GetType()!=BHSI_SITYPE_EPHEMERAL){
		while(iter->GetType()!=BHSI_SITYPE_EPHEMERAL && iter!=items.end()){ 
			iter++;
		}
		if(iter==items.end()){
		   return 0;
		}
		si=*iter;
		items.erase(iter);
	}
	else if(iter->GetType()==BHSI_SITYPE_EPHEMERAL){
	   items.pop_front();
	}
	else{
	   return 0;
	}
	
   numephemeral--;
	
	return 1;
}
/*
int CTransItems::Edit(CSaleItem& si)
{
   if(!Exists(si)){
      return 0;
	}
}

int CTransItems::Edit(int n, CSaleItem& si)
{
   if(!Exists(n, si)){
      return 0;
	}
   *i=si;
   
   return 1;
}
*/
int CTransItems::Decrement(CSaleItem& si, int *i)
{
	if(!Exists(si)){
      return 0;
	}
	si.SetQuantity(si.GetQuantity()-1);
	if(si.GetQuantity()==0){
		Delete(si);
      *i=0;
      return 2;
	}
   else{
      Update(si);
      *i=si.GetQuantity();
      return 1;
   }
	return 0;
}

int CTransItems::Exists(CSaleItem& si)
{
   if(items.empty()) return -1;
   
   std::list<CSaleItem>::iterator i=find(items.begin(), items.end(), si);
	if(i!=items.end()){
      si=*i;
		return true;
	}
	return false;
}

int CTransItems::Exists(int x, CSaleItem& si)
{
   if(items.empty()) return -1;
   
   std::list<CSaleItem>::iterator i=items.begin();
   int n=x;
   while(n){
      i++;
      n--;
      if(i==items.end()){
	      return false;
	   }
   }
	if(si==*i) return true;
      
	return false;
}

int CTransItems::Exists(CPayItem& pi)
{
   if(p_items.empty()) return -1;

	int							  idx=0;
	std::list<CPayItem>::iterator iter=p_items.begin();

	while(*iter!=pi){
		iter++;
		idx++;
	}
	if(iter==p_items.end()){
	   return -1;
	}
	pi=*iter;
		
	return idx;
}

void CTransItems::Clear()
{
   discount_type=BHTRANS_DISCOUNT_NONE;
	numunknown=0;
   numprice=0;
	numreturn=0;
   numlayby=0;
   numrental=0;
   numephemeral=0;
   numredemption=0;
   userid=0;
   strcpy(userName, "");
   
   total_items=0.0;
   total=0.0;
   discount_margin=0.0;
	total_discount=0.0;
	total_tax=0.0;
	sub_total=0.0;
	total_tendered=0.0;
	cash_tendered=0.0;
	cash_change=0.0;
	total_return=0.0;
   total_layby=0.0;
   layby_deposit=0.0;
   rental_deposit=0.0;
	
	items.clear();
	p_items.clear();
   rr_items.clear();
}

void CTransItems::ClearPayItems()
{
	total_tendered=0.0;
	cash_tendered=0.0;
	cash_change=0.0;
	p_items.clear();
}

int CTransItems::GetPayItem(CPayItem& pi)
{
   if(p_items.empty()) return 1;
   
	std::list<CPayItem>::iterator iter=p_items.end();
	iter--;
	if(iter==p_items.begin()) return 2;
	pi=*iter;
	
	return 0;
}

int CTransItems::GetPayItem(int i, CPayItem& pi)
{
	if(p_items.empty()) return 1;
	
	int x=i;
	std::list<CPayItem>::iterator iter=p_items.begin();
	while(x){ iter++; x--;}
	if(iter==p_items.end()) return 2;
	pi=*iter;
	
	return 0;
}

int CTransItems::PaymentExists(CPayItem& pi)
{
	if(p_items.empty()) return 0;
	int c=0;
	std::list<CPayItem>::iterator iter=p_items.begin();
	while(iter!=p_items.end()){
		if(*iter==pi) return c;
		c++;
		iter++;
	}
	
	return 0;
}

int CTransItems::AddPayment(CPayItem& pi, bool bUpdate)
{
	int ret=0;
	std::list<CPayItem>::iterator iter=find(p_items.begin(), p_items.end(), pi);
	
	if(iter==p_items.end()){
		p_items.push_back(pi);
		if(bUpdate){
		   total_tendered+=pi.GetAmount();
   		if((total_tendered - total) >= 0.0){
			   ret=1;
   			if(pi.GetID()==PTYPE_CASH){
			   	cash_change=total_tendered - total;
   			}
		   }
		}
	}
	else{
	   if(bUpdate){
   		total_tendered+=pi.GetAmount();
   		iter->AddAmount(pi.GetAmount());
   		if((total_tendered - total) >= 0.0){
			   ret=1;
   			if(pi.GetID()==PTYPE_CASH){
			   	cash_change=total_tendered - total;
   			}
		   }
		}
	}
   status=BHTRANS_STATUS_TENDER;
	return ret;
}

int CTransItems::DeletePayment(int i)
{
	if(items.empty()) return 1;
	
	int x=i;
	std::list<CPayItem>::iterator iter=p_items.begin();
	while(x){ iter++; x--;}
	if(iter==p_items.end()) return 2;
	
	p_items.erase(iter);
	if(p_items.empty()){
      status=BHTRANS_STATUS_IDLE;
   }
	return 0;
}

int CTransItems::DeletePayment(CPayItem& pi)
{
	std::list<CPayItem>::iterator iter=find(p_items.begin(), p_items.end(), pi);
	
	if(iter==p_items.end()) return 1;
	
	p_items.erase(iter);
	if(p_items.empty()){
      status=BHTRANS_STATUS_IDLE;
   }
	return 0;
}
int CTransItems::PopPayment(CPayItem& pi)
{
	if(p_items.empty()) return 0;
	
	pi=p_items.back();
	p_items.pop_back();
	return 1;
}
const int CTransItems::NumAllItemsQty()
{
	std::list<CSaleItem>::iterator iter;
	int count=0;
	
	for(iter=items.begin(); iter!=items.end(); iter++){ 
		count+=iter->GetQuantity();
	}
	return count;
}

int CTransItems::StoreTransaction()
{
	return 0;
}

int CTransItems::RetrieveTransaction()
{
	return 0;
}

void CTransItems::SetRoundType(BhTransRoundType t)
{
   currencyRound=t;
}

double CTransItems::Round(double amount)
{
   char   buff[64];
   double a=amount, y;
   int z;
   
   switch(currencyRound){
   case BHTRANS_ROUND_NONE:
      a=amount;
      break;
   
   case BHTRANS_ROUND_ROUND:
      if(roundvalue!=0.0){
         y=amount/roundvalue;
         y=rint(y);
         a=(y*roundvalue);
      }
      break;
      
   case BHTRANS_ROUND_UP:
      if(roundvalue!=0.0){   
         y=amount/roundvalue;
         y=ceil(y);
         a=(y*roundvalue);
      }
      break;
      
   case BHTRANS_ROUND_DOWN:
      if(roundvalue!=0.0){
         z==amount/roundvalue;
         a=(z*roundvalue);
      }
      break;
   }
   
   sprintf(buff, "%0.2f", a);
   a=atof(buff);

   return a;
}

}
